<template>
  <article class="view view--search">
    <LoadingSpinner v-if="loading" />
    <SearchResultsListItem v-for="result in results" :key="result.key" :result="result" />
    <div v-if="loaded && results.length === 0">No results found.</div>
    <PaginationNav
      v-if="showPagination"
      :total="total"
      :offset="offset"
      :limit="limit"
      singular="result"
      plural="results"
    />
  </article>
</template>

<script>
import { ref, computed, onMounted, watch } from 'vue'
import { useRoute } from 'vue-router'
import { Constants, ValidationHelper, LoadingSpinner, PaginationNav, useApi, useNotification } from '../../../core'
import { useAuth } from '../../../identity'
import SearchApi from '../../api/search-api.js'
import SearchResultsListItem from './search-results-list-item.vue'

export default {
  name: 'SearchView',
  components: {
    LoadingSpinner,
    PaginationNav,
    SearchResultsListItem,
  },
  setup() {
    const route = useRoute()
    const api = useApi()
    const auth = useAuth()
    const notify = useNotification()
    const searchApi = new SearchApi(api, auth)

    const loading = ref(false)
    const loaded = ref(false)
    const results = ref([])
    const total = ref(0)

    const q = computed(() => {
      return ValidationHelper.getString(route.query.q, '')
    })

    const offset = computed(() => {
      return ValidationHelper.getInteger(route.query.offset, 0)
    })

    const limit = computed(() => {
      return ValidationHelper.getInteger(route.query.limit, Constants.pagination.defaultPageLimit)
    })

    const showPagination = computed(() => {
      return loaded.value && total.value > limit.value
    })

    const loadAsync = async () => {
      loading.value = true
      loaded.value = false
      results.value = []

      try {
        const response = await searchApi.searchAsync('site', {
          q: q.value,
          offset: offset.value,
          limit: limit.value,
        })

        total.value = parseInt(response.headers['x-total-count'])
        results.value = response.data
        loaded.value = true
      } catch (ex) {
        notify.error('There was a problem getting the search results.', ex)
      } finally {
        loading.value = false
      }
    }

    onMounted(async () => {
      await loadAsync()
    })

    watch(q, async () => {
      await loadAsync()
    })

    watch(offset, async () => {
      await loadAsync()
    })

    watch(limit, async () => {
      await loadAsync()
    })

    return {
      loading,
      loaded,
      results,
      total,
      q,
      offset,
      limit,
      showPagination,
    }
  },
}
</script>
